## qbe 1.2

=== Makefile ===
.POSIX:
.SUFFIXES: .o .c

PREFIX = /usr/local
BINDIR = $(PREFIX)/bin

COMMOBJ  = main.o util.o parse.o abi.o cfg.o mem.o ssa.o alias.o load.o \
           copy.o fold.o simpl.o live.o spill.o rega.o emit.o
AMD64OBJ = amd64/targ.o amd64/sysv.o amd64/isel.o amd64/emit.o
ARM64OBJ = arm64/targ.o arm64/abi.o arm64/isel.o arm64/emit.o
RV64OBJ  = rv64/targ.o rv64/abi.o rv64/isel.o rv64/emit.o
OBJ      = $(COMMOBJ) $(AMD64OBJ) $(ARM64OBJ) $(RV64OBJ)

SRCALL   = $(OBJ:.o=.c)

CC       = cc
CFLAGS   = -std=c99 -g -Wall -Wextra -Wpedantic

qbe: $(OBJ)
	$(CC) $(LDFLAGS) $(OBJ) -o $@

.c.o:
	$(CC) $(CFLAGS) -c $< -o $@

$(OBJ): all.h ops.h
$(AMD64OBJ): amd64/all.h
$(ARM64OBJ): arm64/all.h
$(RV64OBJ): rv64/all.h
main.o: config.h

config.h:
	@case `uname` in                               \
	*Darwin*)                                      \
		case `uname -m` in                     \
		*arm64*)                               \
			echo "#define Deftgt T_arm64_apple";\
			;;                             \
		*)                                     \
			echo "#define Deftgt T_amd64_apple";\
			;;                             \
		esac                                   \
		;;                                     \
	*)                                             \
		case `uname -m` in                     \
		*aarch64*|*arm64*)                     \
			echo "#define Deftgt T_arm64"; \
			;;                             \
		*riscv64*)                             \
			echo "#define Deftgt T_rv64";  \
			;;                             \
		*)                                     \
			echo "#define Deftgt T_amd64_sysv";\
			;;                             \
		esac                                   \
		;;                                     \
	esac > $@

install: qbe
	mkdir -p "$(DESTDIR)$(BINDIR)"
	install -m755 qbe "$(DESTDIR)$(BINDIR)/qbe"

uninstall:
	rm -f "$(DESTDIR)$(BINDIR)/qbe"

clean:
	rm -f *.o */*.o qbe

clean-gen: clean
	rm -f config.h

check: qbe
	tools/test.sh all

check-arm64: qbe
	TARGET=arm64 tools/test.sh all

check-rv64: qbe
	TARGET=rv64 tools/test.sh all

src:
	@echo $(SRCALL)

80:
	@for F in $(SRCALL);                       \
	do                                         \
		awk "{                             \
			gsub(/\\t/, \"        \"); \
			if (length(\$$0) > $@)     \
				printf(\"$$F:%d: %s\\n\", NR, \$$0); \
		}" < $$F;                          \
	done

.PHONY: clean clean-gen check check-arm64 src 80 install uninstall

=== minic/Makefile ===
BIN = minic

CFLAGS += -g -Wall

$(BIN): yacc minic.y
	./yacc minic.y
	$(CC) $(CFLAGS) -o $@ y.tab.c

clean:
	rm -f yacc minic y.*

.PHONY: clean

=== debian/changelog ===
qbe (1.2-3) unstable; urgency=medium

  [ Guilherme Puida Moreira ]
  * Skip autopkgtests on ppc64el and s390x.

 -- Miguel Landaeta <nomadium@debian.org>  Fri, 21 Mar 2025 21:48:05 +0000

qbe (1.2-2) unstable; urgency=medium

  [ Antonio Terceiro ]
  * Patch the test runner to make it more portable and run tests
    for all supported targets during build and under autopkgtest.
    (Closes: #1070495)

 -- Miguel Landaeta <nomadium@debian.org>  Wed, 26 Feb 2025 22:16:48 +0000

qbe (1.2-1) unstable; urgency=medium

  * Initial release. (Closes: #1058646)
    Thanks to Guilherme Puida Moreira for contributing an initial manpage
    for this package.

 -- Miguel Landaeta <nomadium@debian.org>  Sun, 28 Apr 2024 19:53:49 +0100

=== debian/control ===
Source: qbe
Section: devel
Priority: optional
Maintainer: Miguel Landaeta <nomadium@debian.org>
Uploaders:
 Amin Bandali <bandali@debian.org>
Build-Depends: debhelper-compat (= 13), dctrl-tools
Standards-Version: 4.6.2
Homepage: https://c9x.me/compile/
Vcs-Git: https://salsa.debian.org/debian/qbe.git
Vcs-Browser: https://salsa.debian.org/debian/qbe
Rules-Requires-Root: no

Package: qbe
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: Small embeddable C compiler backend
 QBE is a compiler backend that aims to provide 70% of the performance
 of industrial optimizing compilers in 10% of the code.
 QBE fosters language innovation by offering a compact user-friendly
 and performant backend. The size limit constrains QBE to focus on the
 essential and prevents embarking on a never-ending path of diminishing
 returns.

=== debian/rules ===
#!/usr/bin/make -f
export DEB_BUILD_MAINT_OPTIONS = hardening=+all
%:
	dh $@

override_dh_auto_clean:
	dh_auto_clean
	-rm -f config.h qbe.1

override_dh_auto_build:
	dh_auto_build


backends = $(shell grep-dctrl -v -s Tests -n native debian/tests/control)

.PHONY: $(backends)

override_dh_auto_test: $(backends)

$(backends):
	debian/tests/$@; test $$? -eq 0 -o $$? -eq 77

override_dh_auto_install:
	dh_auto_install -- PREFIX=/usr

=== debian/tests/control ===
Tests: amd64
Depends: @, qemu-user [!amd64], gcc-x86-64-linux-gnu, libc6-dev-amd64-cross
Restrictions: skippable, skip-not-installable
Architecture: !ppc64el !s390x

Tests: arm64
Depends: @, qemu-user [!arm64], gcc-aarch64-linux-gnu, libc6-dev-arm64-cross
Restrictions: skippable, skip-not-installable
Architecture: !ppc64el !s390x

Tests: rv64
Depends: @, qemu-user [!riscv64], gcc-riscv64-linux-gnu, libc6-dev-riscv64-cross
Restrictions: skippable, skip-not-installable
Architecture: !ppc64el !s390x

Tests: native
Depends: @, gcc, libc6-dev
Architecture: amd64, arm64, riscv64

=== debian/watch ===
version=4
https://c9x.me/compile/releases.html /.+@PACKAGE@@ANY_VERSION@@ARCHIVE_EXT@
